﻿<%
'///////////////////////////////////////////////////////////////////////////////
'//              Z-Blog
'// 作    者:    朱煊(zx.asd)
'// 版权所有:    RainbowSoft Studio
'// 技术支持:    rainbowsoft@163.com
'// 程序名称:    
'// 程序版本:    
'// 单元名称:    c_system_base.asp
'// 开始时间:    2005.02.11
'// 最后修改:    
'// 备    注:    
'///////////////////////////////////////////////////////////////////////////////


'定义全局变量
Dim objConn

Dim BlogTitle
Dim BlogUser

Dim BlogPath
BlogPath=Server.MapPath("c_system_base.asp")
BlogPath=Left(BlogPath,Len(BlogPath)-Len("c_system_base.asp"))

Dim StarTime
Dim EndTime
StarTime = Timer()

Dim Categorys()
Dim Users()
Dim Tags()
Dim KeyWords

Dim ArticleList
Dim AuthList
Dim CateList
Dim TagsList



'*********************************************************
' 目的：    System 初始化
'*********************************************************
Sub System_Initialize()

	On Error Resume Next

	If OpenConnect()=False Then Call ShowError(4)

	Set BlogUser =New TUser

	BlogUser.Verify()

	If Err.Number<>0 Then Call ShowError(10)

End Sub
'*********************************************************




'*********************************************************
' 目的：    System 释放
'*********************************************************
Sub System_Terminate()

	Call CloseConnect()

End Sub
'*********************************************************




'*********************************************************
' 目的：    数据库连接
'*********************************************************
Function OpenConnect()

	'判定是否为子目录调用
	Dim strDbPath
	strDbPath=BlogPath & "/" & ZC_DATABASE_PATH

	Set objConn = Server.CreateObject("ADODB.Connection")
	objConn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strDbPath

	OpenConnect=True

End Function
'*********************************************************




'*********************************************************
' 目的：    DB Disable Connect
'*********************************************************
Function CloseConnect()

	objConn.Close
	Set objConn=Nothing

End Function
'*********************************************************




'*********************************************************
' 目的：    时间计长
'*********************************************************
Function RunTime()

	EndTime=Timer()
	RunTime = CStr(CInt(FormatNumber((EndTime-StarTime)*1000,3))) & "ms"

End Function
'*********************************************************




'*********************************************************
' 目的：    分类读取
'*********************************************************
Function GetCategory()

	Dim i,j,k,l

	Dim aryAllData
	Dim arySingleData()

	Dim objRS

	Set objRS=objConn.Execute("SELECT TOP 1 [cate_ID] FROM [blog_Category] ORDER BY [cate_ID] DESC")
	If (Not objRS.bof) And (Not objRS.eof) Then
		i=objRS("cate_ID")
		ReDim Categorys(i)
	End If
	objRS.Close
	Set objRS=Nothing

	Set objRS=objConn.Execute("SELECT [cate_ID],[cate_Name],[cate_Intro],[cate_Order],[cate_Count] FROM [blog_Category] ORDER BY [cate_ID] ASC")
	If (Not objRS.bof) And (Not objRS.eof) Then

		aryAllData=objRS.GetRows(objRS.RecordCount)
		objRS.Close
		Set objRS=Nothing

		k=UBound(aryAllData,1)
		l=UBound(aryAllData,2)
		For i=0 To l
			Erase arySingleData
			ReDim arySingleData(k)
			For j=0 To k
				arySingleData(j)=aryAllData(j,i)
			Next
			Set Categorys(aryAllData(0,i))=New TCategory
			Categorys(aryAllData(0,i)).LoadInfoByArray(arySingleData)
		Next

	End If

	GetCategory=True

End Function
'*********************************************************




'*********************************************************
' 目的：    用户读取
'*********************************************************
Function GetUser()

	Dim i,j,k,l

	Dim aryAllData
	Dim arySingleData()

	Dim objRS

	Set objRS=objConn.Execute("SELECT TOP 1 [mem_ID] FROM [blog_Member] ORDER BY [mem_ID] DESC")
	If (Not objRS.bof) And (Not objRS.eof) Then
		i=objRS("mem_ID")
		ReDim Users(i)
	End If
	objRS.Close
	Set objRS=Nothing


	Set objRS=objConn.Execute("SELECT [mem_ID],[mem_Name],[mem_Level],[mem_Password],[mem_Email],[mem_HomePage],[mem_PostLogs] FROM [blog_Member] ORDER BY [mem_ID] ASC")
	If (Not objRS.bof) And (Not objRS.eof) Then

		aryAllData=objRS.GetRows(objRS.RecordCount)
		objRS.Close
		Set objRS=Nothing

		k=UBound(aryAllData,1)
		l=UBound(aryAllData,2)
		For i=0 To l
			Erase arySingleData
			ReDim arySingleData(k)
			For j=0 To k
				arySingleData(j)=aryAllData(j,i)
			Next
			Set Users(aryAllData(0,i))=New TUser
			Users(aryAllData(0,i)).LoadInfoByArray(arySingleData)
		Next

	End If

	Getuser=True

End Function
'*********************************************************




'*********************************************************
' 目的：    Tags读取
'*********************************************************
Function GetTags()

	Dim i,j,k,l

	Dim aryAllData
	Dim arySingleData()

	Dim objRS

	Set objRS=objConn.Execute("SELECT TOP 1 [tag_ID] FROM [blog_Tag] ORDER BY [tag_ID] DESC")
	If (Not objRS.bof) And (Not objRS.eof) Then
		i=objRS("tag_ID")
		ReDim Tags(i)
	End If

	Set objRS=objConn.Execute("SELECT [tag_ID],[tag_Name],[tag_Intro],[tag_Order],[tag_Count] FROM [blog_Tag] ORDER BY [tag_ID] ASC")
	If (Not objRS.bof) And (Not objRS.eof) Then

		aryAllData=objRS.GetRows(objRS.RecordCount)
		objRS.Close
		Set objRS=Nothing

		k=UBound(aryAllData,1)
		l=UBound(aryAllData,2)
		For i=0 To l
			Erase arySingleData
			ReDim arySingleData(k)
			For j=0 To k
				arySingleData(j)=aryAllData(j,i)
			Next
			Set Tags(aryAllData(0,i))=New TTag
			Tags(aryAllData(0,i)).LoadInfoByArray(arySingleData)
		Next

	End If

	GetTags=True

End Function
'*********************************************************




'*********************************************************
' 目的：    KeyWords读取
'*********************************************************
Function GetKeyWords()

	Dim objRS
	Set objRS=objConn.Execute("SELECT [key_ID],[key_Name],[key_URL] FROM [blog_Keyword] ORDER BY [key_ID] ASC")

	If (Not objRS.bof) And (Not objRS.eof) Then
		KeyWords=objRS.GetRows
	End If

	objRS.Close
	Set objRS=Nothing

	GetKeyWords=True

End Function
'*********************************************************




'*********************************************************
' 目的：    Show Calendar
'*********************************************************
Function ShowCalendar(dtmYearMonth)

	If IsEmpty(dtmYearMonth)=False Then
		On Error Resume Next
		Server.Execute("cache/Calendar" & Year(dtmYearMonth) & "-" & Month(dtmYearMonth) & ".asp")
		If Err.Number<>0 then
			Application.Lock
			Response.Write Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_CALENDAR")
			Application.UnLock
		End If
		Err.Clear
	Else
		Application.Lock
		Response.Write Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_CALENDAR")
		Application.UnLock
	End If

	ShowCalendar=True

End Function
'*********************************************************




'*********************************************************
' 目的：    读取权限
' 备注:     权限最高为1 最低为5 不是则非法
'           "Root"一定只能为1
'           权限配置方式可以变通
'*********************************************************
Function GetRights(strAction)

	Select Case strAction

		Case "login"
			GetRights=5
		Case "verify"
			GetRights=5
		Case "logout"
			GetRights=5
		Case "admin"
			GetRights=4
		Case "cmt"
			GetRights=5
		Case "tb"
			GetRights=5
		Case "vrs"
			GetRights=5
		Case "ArticleMng"
			GetRights=2
		Case "ArticleEdt"
			GetRights=2
		Case "ArticlePst"
			GetRights=2
		Case "ArticleDel"
			GetRights=2
		Case "ArticleBud"
			GetRights=2
		Case "CategoryMng"
			GetRights=1
		Case "CategoryEdt"
			GetRights=1
		Case "CategoryPst"
			GetRights=1
		Case "CategoryDel"
			GetRights=1
		Case "TagMng"
			GetRights=1
		Case "TagEdt"
			GetRights=1
		Case "TagPst"
			GetRights=1
		Case "TagDel"
			GetRights=1
		Case "KeyWordMng"
			GetRights=1
		Case "KeyWordEdt"
			GetRights=1
		Case "KeyWordPst"
			GetRights=1
		Case "KeyWordDel"
			GetRights=1
		Case "CommentMng"
			GetRights=3
		Case "CommentDel"
			GetRights=3
		Case "TrackBackMng"
			GetRights=2
		Case "TrackBackDel"
			GetRights=2
		Case "TrackBackSnd"
			GetRights=2
		Case "UserMng"
			GetRights=4
		Case "UserEdt"
			GetRights=4
		Case "UserDel"
			GetRights=1
		Case "UserCrt"
			GetRights=1
		Case "BlogReBuild"
			GetRights=3
		Case "FileReBuild"
			GetRights=1
		Case "FileMng"
			GetRights=2
		Case "FileUpload"
			GetRights=2
		Case "FileDel"
			GetRights=2
		Case "Search"
			GetRights=5
		Case "BlogMng"
			GetRights=1
		Case "SettingMng"
			GetRights=1
		Case "SettingSav"
			GetRights=1
		Case "PlugInMng"
			GetRights=1
		Case "rss"
			GetRights=5
		Case "Root"
			GetRights=1
		Case "ExportXml"
			GetRights=1
		Case Else Call ShowError(1)

	End Select

End Function
'*********************************************************




'*********************************************************
' 目的：    检查权限
'*********************************************************
Function CheckRights(strAction)

	If BlogUser.Level>GetRights(strAction) Then
		CheckRights=False
	Else
		CheckRights=True
	End If

End Function
'*********************************************************




'*********************************************************
' 目的：    Load List By Cache
'*********************************************************
Function LoadListByCache()

	Dim objStream
	Dim strContent

	If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_LIST"))=True) Then
		Application.Lock

		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_LIST.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_LIST")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_CATE.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_CATE")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_AUTH.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_AUTH")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/CACHE/CACHE_TAGS.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_TAGS")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/INCLUDE/calendar.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_CALENDAR")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/INCLUDE/navbar.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_NAVBAR")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/TEMPLATE/single." & ZC_STATIC_TYPE
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_SINGLE")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/include/comments.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_COMMENTS")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/include/previous.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_PREVIOUS")=strContent


		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/include/tags.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_TAGS")=strContent



		strContent=""
		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.LoadFromFile BlogPath & "/include/archives.asp"
		strContent=.ReadText
		.Close
		End With
		Set objStream = NoThing

		Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_ARCHIVES")=strContent

		Application.UnLock
	End If

	If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_LIST"))=False) Then
		Application.Lock
		ArticleList=Application(ZC_BLOG_CLSID & "CACHE_LIST")
		CateList=Application(ZC_BLOG_CLSID & "CACHE_CATE")
		AuthList=Application(ZC_BLOG_CLSID & "CACHE_AUTH")
		TagsList=Application(ZC_BLOG_CLSID & "CACHE_TAGS")
		Application.UnLock
	End If

	LoadListByCache=True

End Function
'*********************************************************



'*********************************************************
' 目的：    Clear List and Cache
'*********************************************************
Function ClearListByCache()

	Application.Lock
	Application(ZC_BLOG_CLSID & "CACHE_LIST")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_CATE")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_AUTH")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_TAGS")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_CALENDAR")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_NAVBAR")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_SINGLE")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_COMMENTS")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_PREVIOUS")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_ARCHIVES")=Empty
	Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_TAGS")=Empty
	Application.UnLock

	ClearListByCache=True

End Function
'*********************************************************


'*********************************************************
' 目的：    Parse List
'*********************************************************
Function ParseList(intPage,intCateId,intAuthorId,dtmYearMonth,strTagsName)

	Dim strType
	Dim i
	Dim j
	Dim s
	Dim aryList
	Dim intAllPage
	Dim intTagsID

	Call CheckParameter(intPage,"int",1)
	Call CheckParameter(intCateId,"int",Empty)
	Call CheckParameter(intAuthorId,"int",Empty)
	Call CheckParameter(dtmYearMonth,"dtm",Empty)


	i=InStr(1,TagsList,vbTab & strTagsName & vbVerticalTab,vbBinaryCompare)
	If i>0 Then
		j=Left(TagsList,i-1)
		i=InStrRev(j,vbTab)
		intTagsID=Right(j,Len(j)-i)
		Call CheckParameter(intTagsID,"int",Empty)
	End If


	If dtmYearMonth<>"" Then
		strType="Date" & CStr(Year(dtmYearMonth) & "-" & Month(dtmYearMonth)) & "Page" & CStr(intPage) & "["
		s="Date" & CStr(Year(dtmYearMonth) & "-" & Month(dtmYearMonth)) & "Page"
	ElseIf intTagsID>0 Then
		strType="Tags" & CStr(intTagsID) & "Page" & CStr(intPage) & "["
		s="Tags" & CStr(intTagsID) & "Page"
	ElseIf intCateID>0 Then
		strType="Cate" & CStr(intCateId) & "Page" & CStr(intPage) & "["
		s="Cate" & CStr(intCateId) & "Page"
	ElseIf intAuthorID>0 Then
		strType="Auth" & CStr(intAuthorId) & "Page" & CStr(intPage) & "["
		s="Auth" & CStr(intAuthorId) & "Page"
	ElseIf intTagsID>0 Then
		strType="Tags" & CStr(intAuthorId) & "Page" & CStr(intPage) & "["
		s="Tags" & CStr(intAuthorId) & "Page"
	Else
		strType="All" & "Page" & CStr(intPage) & "["
		s="All" & "Page"
	End If

	i=InStrRev(ArticleList,s)
	If i>0 Then
		j=InStr(i,ArticleList,"[",vbBinaryCompare)
		s=Mid(ArticleList,i+Len(s),j-i-Len(s))
		intAllPage=CInt(s)
	Else
		Exit Function
	End If

	i=InStr(1,ArticleList,strType,vbBinaryCompare)
	If i>0 Then
		i=Len(strType)+i
		j=InStr(i,ArticleList,"]",vbBinaryCompare)
		s=Mid(ArticleList,i,j-i)
		aryList=Split(s,";")
	Else
		Exit Function
	End If

	For i=LBound(aryList) To UBound(aryList)-1
		On Error Resume Next
		Server.Execute("cache/" & aryList(i) & ".asp")
		Err.Clear
	Next

	Response.Write ExportBar(intPage,intAllPage,intCateId,intAuthorId,dtmYearMonth,strTagsName)

	ParseList=True

End Function
'*********************************************************




'*********************************************************
' 目的：    ExportBar
'*********************************************************
Function ExportBar(intNowPage,intAllPage,intCateId,intAuthorId,dtmYearMonth,strTagsName)

	Dim i
	Dim s
	Dim t
	Dim strPageBar
	If Not IsEmpty(intCateId) Then t=t & "cate=" & intCateId & "&amp;"
	If Not IsEmpty(dtmYearMonth) Then t=t & "date=" & Year(dtmYearMonth) & "-" & Month(dtmYearMonth) & "&amp;"
	If Not IsEmpty(intAuthorId) Then t=t & "auth=" & intAuthorId & "&amp;"
	If Not IsEmpty(strTagsName) Then t=t & "tags=" & Server.URLEncode(strTagsName) & "&amp;"
	If intAllPage>0 Then
		Dim a,b
		strPageBar=strPageBar & "<div class=""post pagebar"">" & ZC_MSG042 & ": "
		strPageBar=strPageBar & "<a href=""catalog.asp?"& t &"page=1"">[&lt;&lt;]</a> "
		If intAllPage>ZC_PAGEBAR_COUNT Then
			a=intNowPage
			b=intNowPage+ZC_PAGEBAR_COUNT
			If a>ZC_PAGEBAR_COUNT Then a=a-1:b=b-1
			If b>intAllPage Then b=intAllPage:a=intAllPage-ZC_PAGEBAR_COUNT
		Else
			a=1:b=intAllPage
		End If
		For i=a to b
			s=s+ "<a href=""catalog.asp?"& t &"page="& i &""">[" & i & "]</a> "
		Next
		strPageBar=strPageBar+s
		strPageBar=strPageBar+ "<a href=""catalog.asp?"& t &"page="& intAllPage &""">[&gt;&gt;]</a> "
		strPageBar=strPageBar+ "</div>"
	End If
	ExportBar=vbCrlf & strPageBar

End Function
'*********************************************************





'*********************************************************
' 目的：    Translate Tag To Name
'*********************************************************
Function TranslateTagToName(strTag)

	Dim t,i,s,j

	If IsNull(strTag) Or strTag="" Then Exit Function

	strTag=Replace(strTag,"}","")
	t=Split(strTag,"{")

	For i=LBound(t) To UBound(t)
		If t(i)<>"" Then
			t(i)=FilterSQL(t(i))
			t(i)=Tags(t(i)).Name
		End If
	Next

	s=Trim(Join(t)) & " "
	If s=" " Then s=""

	TranslateTagToName=s

End Function
'*********************************************************




'*********************************************************
' 目的：    Translate Tag To Name
'*********************************************************
Function TranslateTagToNameWithLink(strTag)

	Dim t,i,s,j

	If IsNull(strTag) Or strTag="" Then Exit Function

	strTag=Replace(strTag,"}","")
	t=Split(strTag,"{")

	For i=LBound(t) To UBound(t)
		If t(i)<>"" Then
			t(i)=FilterSQL(t(i))
			t(i)=Tags(t(i)).Name
			j=j & "<a href=""" & ZC_BLOG_HOST & "catalog.asp?tags=" & Server.URLEncode(t(i)) & """>" & t(i) & "</a>" & ",&nbsp;"
		End If
	Next

	j=Left(j,Len(j)-7)

	TranslateTagToNameWithLink=j

End Function
'*********************************************************




'*********************************************************
' 目的：    Parse Tag 并格式化
'*********************************************************
Function ParseTag(strTag)

	Dim s
	Dim t
	Dim i
	Dim Tag
	Dim b
	Dim objTag

	strTag=Trim(strTag)
	t=Split(strTag," ")

	GetTags()
	For i=LBound(t) To UBound(t)

		b=False

		For Each Tag in Tags
			If IsObject(Tag) Then
				If Tag.Name=t(i) Then
					b=True
				End If
			End If
		Next

		If b=False Then
			Set objTag=New TTag
			objTag.ID=0
			objTag.Name=t(i)
			objTag.Order=0
			objTag.Intro=""
			objTag.Post
			Set objTag=Nothing
		End If

	Next

	GetTags()
	For i=LBound(t) To UBound(t)
		For Each Tag in Tags
			If IsObject(Tag) Then
				If Tag.Name=t(i) Then
					t(i)="{"&Tag.ID&"}"
				End If
			End If
		Next
	Next

	s=Join(t)
	s=Replace(s," ","")

	ParseTag=s

End Function
'*********************************************************
%>