﻿<%
'///////////////////////////////////////////////////////////////////////////////
'//              Z-Blog
'// 作    者:    朱煊(zx.asd)
'// 版权所有:    RainbowSoft Studio
'// 技术支持:    rainbowsoft@163.com
'// 程序名称:    
'// 程序版本:    
'// 单元名称:    c_system_lib.asp
'// 开始时间:    2004.07.25
'// 最后修改:    
'// 备    注:    库模块
'///////////////////////////////////////////////////////////////////////////////




'*********************************************************
' 目的：    定义TCategory类
' 输入：    无
' 返回：    无
'*********************************************************
Class TCategory

	Public ID
	Public Name
	Public Intro
	Public Order
	Public Count

	Public Function Post()

		Call CheckParameter(ID,"int",0)
		Call CheckParameter(Order,"int",0)

		'ID可以为0
		Name=FilterSQL(Name)
		Intro=FilterSQL(Intro)
		If Len(Name)=0 Then Post=False:Exit Function

		If ID=0 Then
			objConn.Execute("INSERT INTO [blog_Category]([cate_Name],[cate_Order],[cate_Intro]) VALUES ('"&Name&"',"&Order&",'"&Intro&"')")
		Else
			objConn.Execute("UPDATE [blog_Category] set [cate_Name]='"&Name&"',[cate_Order]="&Order&",[cate_Intro]='"&Intro&"' WHERE [cate_ID] =" & ID)
		End If

		Post=True

	End Function


	Public Function LoadInfoByID(cate_ID)

		Call CheckParameter(cate_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT [cate_ID],[cate_Name],[cate_Intro],[cate_Order],[cate_Count] FROM [blog_Category] WHERE [cate_ID]=" & cate_ID)

		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("cate_ID")
			Name=objRS("cate_Name")
			Intro=objRS("cate_Intro")
			Order=objRS("cate_Order")
			Count=objRS("cate_Count")

		Else
			Exit Function
		End If

		objRS.Close
		Set objRS=Nothing

		LoadInfoByID=True

	End Function


	Public Function LoadInfoByArray(aryCateInfo)

		If IsArray(aryCateInfo)=True Then
			ID=aryCateInfo(0)
			Name=aryCateInfo(1)
			Intro=aryCateInfo(2)
			Order=aryCateInfo(3)
			Count=aryCateInfo(4)
		End If

		LoadInfoByArray=True

	End Function


	Public Function Del()

		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function
		Dim objRS
		Set objRS=objConn.Execute("SELECT [log_ID] FROM [blog_Article] WHERE [log_CateID]=" & ID)

		If (Not objRS.bof) And (Not objRS.eof) Then  ShowError(13)

		objConn.Execute("DELETE FROM [blog_Category] WHERE [cate_ID] =" & ID)
		Del=True
	End Function

End Class
'*********************************************************




'*********************************************************
' 目的：    定义TArticle类
' 输入：    无
' 返回：    无
'*********************************************************
Class TArticle

	Public ID
	Public CateID
	Public AuthorID
	Public Level

	Public Title
	Public Intro
	Public Content
	Public PostTime

	Public CommNums
	Public ViewNums
	Public TrackBackNums

	Private IP

	Public Cate
	Public Author
	Public Url
	Public Tag


	Public Property Get TrackBack
		TrackBack = ZC_BLOG_HOST & "cmd.asp?act=tb&amp;id=" & ID
	End Property


	Public Function LoadInfobyID(log_ID)

		Call CheckParameter(log_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT [log_ID],[log_Tag],[log_CateID],[log_Title],[log_Intro],[log_Content],[log_Level],[log_AuthorID],[log_PostTime],[log_CommNums],[log_ViewNums],[log_TrackBackNums],[mem_Name],[cate_Name] FROM [blog_Article],[blog_Category],[blog_Member] WHERE [log_CateID]=[cate_ID] AND [log_AuthorID]=[mem_ID] AND [log_ID]=" & log_ID)

		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("log_ID")
			Tag=objRS("log_Tag")
			CateID=objRS("log_CateID")
			Title=objRS("log_Title")
			Intro=objRS("log_Intro")
			Content=objRS("log_Content")
			Level=objRS("log_Level")
			AuthorID=objRS("log_AuthorID")
			PostTime=objRS("log_PostTime")
			CommNums=objRS("log_CommNums")
			ViewNums=objRS("log_ViewNums")
			TrackBackNums=objRS("log_TrackBackNums")
			Author=objRS("mem_Name")
			Cate=objRS("cate_Name")

		Else
			Exit Function
		End If

		objRS.Close
		Set objRS=Nothing

		LoadInfobyID=True

	End Function

	Public Function LoadInfoByArray(aryArticleInfo)

		If IsArray(aryArticleInfo)=True Then
			ID=aryArticleInfo(0)
			Tag=aryArticleInfo(1)
			CateID=aryArticleInfo(2)
			Title=aryArticleInfo(3)
			Intro=aryArticleInfo(4)
			Content=aryArticleInfo(5)
			Level=aryArticleInfo(6)
			AuthorID=aryArticleInfo(7)
			PostTime=aryArticleInfo(8)
			CommNums=aryArticleInfo(9)
			ViewNums=aryArticleInfo(10)
			TrackBackNums=aryArticleInfo(11)
			Author=aryArticleInfo(12)
			Cate=aryArticleInfo(13)
		End If

		LoadInfoByArray=True

	End Function

	Public Function Export(intType)

		Dim s,t
		Dim aryArticleExport(20)

		If (Level=2) And (intType<>ZC_DISPLAY_MODE_ALL) Then intType=ZC_DISPLAY_MODE_HIDE

		aryArticleExport(0)= vbCrlf
		aryArticleExport(1)= "<div class=""post cate"& CateID &" auth"& AuthorID &""">"

		Select Case intType
			Case ZC_DISPLAY_MODE_ALL
				aryArticleExport(4)= ExportNavBar
				aryArticleExport(5)= "<h4 class=""post-date"">" & PostTime & "</h4>"
				aryArticleExport(6)= "<h2 class=""post-title"">"& Title &"</h2>"
			Case ZC_DISPLAY_MODE_LIST
				aryArticleExport(5)= "<h2 class=""post-title""><a href=""post/"& ID &"." & ZC_STATIC_TYPE & """>"& Title &"</a></h2>"
			Case ZC_DISPLAY_MODE_HIDE
				aryArticleExport(5)= "<h2 class=""post-title""><a href=""view.asp?id="& ID &""">"& Title &"</a></h2>"
			Case ZC_DISPLAY_MODE_ONTOP
				aryArticleExport(5)= "<h2 class=""post-title""><a href=""post/"& ID &"." & ZC_STATIC_TYPE & """>"& "[" & ZC_MSG051 & "]" & Title &"</a></h2>"
			Case ZC_DISPLAY_MODE_SEARCH
				aryArticleExport(5)= "<h4 class=""post-date"">" & PostTime & "</h4>"
				t=Request.QueryString("q")
				s=Search(Title,t)
				If s="" Then s=Title
				aryArticleExport(6)= "<h2 class=""post-title""><a href=""post/"& ID &"." & ZC_STATIC_TYPE & """>"& s &"</a></h2>"
			Case Else
				aryArticleExport(5)= "<h4 class=""post-date"">" & FormatDateTime(PostTime,vbLongDate) & "</h4>"
				aryArticleExport(6)= "<h2 class=""post-title""><a href=""post/"& ID &"." & ZC_STATIC_TYPE & """>"& Title &"</a></h2>"
		End Select

		Select Case intType
			Case ZC_DISPLAY_MODE_ALL
				aryArticleExport(10)= "<div class=""post-body"">"
				aryArticleExport(11)= TransferHTML(UBBCode(Content,"[face][link][autolink][font][code][image][typeset][media][flash][key]"),"[vbCrlf][upload]")
				aryArticleExport(12)= "</div>"
			Case ZC_DISPLAY_MODE_INTRO
				aryArticleExport(10)= "<div class=""post-body"">"
				aryArticleExport(11)= ZC_MSG126 & TransferHTML(UBBCode(Intro,"[face][link][autolink][font][code][image][typeset][media][flash][key]"),"[vbCrlf][upload]")
				aryArticleExport(12)= "</div>"
			Case ZC_DISPLAY_MODE_HIDE
				aryArticleExport(10)= "<div class=""post-body"">"
				aryArticleExport(11)= ZC_MSG043
				aryArticleExport(12)= "</div>"
			Case ZC_DISPLAY_MODE_LIST
				aryArticleExport(10)= ""
			Case ZC_DISPLAY_MODE_ONTOP
				aryArticleExport(10)= ""
			Case ZC_DISPLAY_MODE_SEARCH

				s=TransferHTML(Intro,"[<][>][&][""]")
				s=Search(s,t)
				If s="" Then
					s=TransferHTML(Content,"[<][>][&][""]")
					s=Search(s,t)
				End If

				aryArticleExport(10)= "<div class=""post-body"">"
				aryArticleExport(11)= s
				aryArticleExport(12)= "</div>"

		End Select

		Select Case intType
			Case ZC_DISPLAY_MODE_LIST
				aryArticleExport(15)= ""
			Case ZC_DISPLAY_MODE_ONTOP
				aryArticleExport(15)= ""
			Case ZC_DISPLAY_MODE_SEARCH
				aryArticleExport(15)= ""
				aryArticleExport(16)= "<h6 class=""post-footer"">"
				aryArticleExport(17)= ZC_MSG011&":"& Author &" | "&ZC_MSG012&":"& Cate & " | "&ZC_MSG013&":"& CommNums & " | "&ZC_MSG014&":"& TrackBackNums & ""' & " | "&ZC_MSG015&":"& ViewNums & ""
				If Level<4 Then aryArticleExport(18)= " | " & ZVA_Article_Level_Name(Level)
				aryArticleExport(19)= "</h6>"
			Case Else
				aryArticleExport(15)= "<h5 class=""post-tags"">" &ZC_MSG138&": "& TranslateTagToNameWithLink(Tag) & "</h5>"
				aryArticleExport(16)= "<h6 class=""post-footer"">"
				aryArticleExport(17)= ZC_MSG011&":"& Author &" | "&ZC_MSG012&":"& Cate & " | "&ZC_MSG013&":"& CommNums & " | "&ZC_MSG014&":"& TrackBackNums & ""' & " | "&ZC_MSG015&":"& ViewNums & ""
				If Level<4 Then aryArticleExport(18)= " | " & ZVA_Article_Level_Name(Level)
				aryArticleExport(19)= "</h6>"
		End Select

		aryArticleExport(20)= "</div>"

		Export=Join(aryArticleExport)

	End Function


	Public Function Post()

		Call CheckParameter(ID,"int",0)
		Call CheckParameter(CateID,"int",0)
		Call CheckParameter(AuthorID,"int",0)
		Call CheckParameter(Level,"int",0)
		Call CheckParameter(PostTime,"dtm",Empty)

		'ID可以为0
		If (CateID=0) Then Post=False:Exit Function
		If (AuthorID=0) Then Post=False:Exit Function
		If (Level=0) Then Post=False:Exit Function
		If IsEmpty(PostTime) Then Post=False:Exit Function

		Title=FilterSQL(Title)
		Intro=FilterSQL(Intro)
		Content=FilterSQL(Content)
		Tag=FilterSQL(Tag)
		IP=FilterSQL(IP)

		If Len(Title)=0 Then Post=False:Exit Function
		If Len(Content)=0 Then Post=False:Exit Function
		If Len(Intro)=0 Then Intro=Left(Content,ZC_TB_EXCERPT_MAX) & "..."

		If ID=0 Then
			objConn.Execute("INSERT INTO [blog_Article]([log_CateID],[log_AuthorID],[log_Level],[log_Title],[log_Intro],[log_Content],[log_PostTime],[log_IP],[log_Tag]) VALUES ("&CateID&","&AuthorID&","&Level&",'"&Title&"','"&Intro&"','"&Content&"','"&PostTime&"','"&IP&"','"&Tag&"')")
			Dim objRS
			Set objRS=objConn.Execute("SELECT MAX([log_ID]) FROM [blog_Article]")
			If (Not objRS.bof) And (Not objRS.eof) Then
				ID=objRS(0)
			End If
		Else
			objConn.Execute("UPDATE [blog_Article] SET [log_CateID]="&CateID&",[log_AuthorID]="&AuthorID&",[log_Level]="&Level&",[log_Title]='"&Title&"',[log_Intro]='"&Intro&"',[log_Content]='"&Content&"',[log_PostTime]='"&PostTime&"',[log_IP]='"&IP&"',[log_Tag]='"&Tag&"' WHERE [log_ID] =" & ID)
		End If

		If Level=1 Then Call DelFile()
		If Level=2 Then Call DelFile()

		Post=True

	End Function

	Private Function DelFile()

		Dim fso, TxtFile

		Set fso = CreateObject("Scripting.FileSystemObject")
		If fso.FileExists(BlogPath & "/post/" & ID & "." & ZC_STATIC_TYPE) Then
			Set TxtFile = fso.GetFile(BlogPath & "/post/" & ID & "." & ZC_STATIC_TYPE)
			TxtFile.Delete
		End If
		Set fso=Nothing

		Set fso = CreateObject("Scripting.FileSystemObject")
		If fso.FileExists(BlogPath & "/cache/" & ID & ".asp") Then
			Set TxtFile = fso.GetFile(BlogPath & "/cache/" & ID & ".asp")
			TxtFile.Delete
		End If
		Set fso=Nothing

		DelFile=True

	End Function

	Public Function Del()

		Call DelFile()

		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function

		objConn.Execute("DELETE FROM [blog_Article] WHERE [log_ID] =" & ID)
		objConn.Execute("DELETE FROM [blog_Comment] WHERE [log_ID] =" & ID)
		objConn.Execute("DELETE FROM [blog_TrackBack] WHERE [log_ID] =" & ID)

		Del=True

	End Function


	Public Function Statistic()

		Dim objRS
		Set objRS=objConn.Execute("SELECT COUNT([log_ID]) FROM [blog_Comment] WHERE [log_ID] =" & ID)
		If (Not objRS.bof) And (Not objRS.eof) Then
			CommNums=objRS(0)
		End If
		objConn.Execute("UPDATE [blog_Article] SET [log_CommNums]="& CommNums &" WHERE [log_ID] =" & ID)
		Set objRS=Nothing

		Set objRS=objConn.Execute("SELECT COUNT([log_ID]) FROM [blog_TrackBack] WHERE [log_ID] =" & ID)
		If (Not objRS.bof) And (Not objRS.eof) Then
			TrackBackNums=objRS(0)
		End If
		objConn.Execute("UPDATE [blog_Article] SET [log_TrackBackNums]="& TrackBackNums &" WHERE [log_ID] =" & ID)
		Set objRS=Nothing

		Statistic=True

	End Function


	Function ExportMsgTB()

		Dim i
		Dim aryMsgTB(5)
		Dim aryArticleExportMsgTB()
		Dim s

		If ZC_COMMENT_NOFOLLOW_ENABLE Then s="rel=""nofollow"""

		Dim objRS
		Set objRS=Server.CreateObject("ADODB.Recordset")
		objRS.CursorType = adOpenKeyset
		objRS.LockType = adLockReadOnly
		objRS.ActiveConnection=objConn
		objRS.Source="select [comm_ID],[log_ID],[comm_AuthorID],[comm_Author],[comm_Content],[comm_Email],[comm_HomePage],[comm_PostTime],[comm_IP],[comm_Agent] from [blog_Comment] where [blog_Comment].[log_ID]=" & ID &" UNION ALL select [tb_ID],[log_ID],'',[tb_Title],[tb_Excerpt],[tb_Blog],[tb_URL],[tb_PostTime],[tb_IP],[tb_Agent] from [blog_TrackBack] where [blog_TrackBack].[log_ID]="& ID & " order by [comm_PostTime]"

		objRS.Open()

		If (not objRS.bof) And (not objRS.eof) Then

			ReDim aryArticleExportMsgTB(objRS.RecordCount)

			For i=1 To objRS.RecordCount

				If InStr(objRS("comm_Email"),"@")>0 Then

					aryMsgTB(0)= "<ul class=""msg"&" auth"& objRS("comm_AuthorID") &""">"
					aryMsgTB(1)= "<li class=""msgname""><a name=""cmt"& objRS("comm_ID") &""">"&i&"</a>.|<a href=""mailto:"&replace(objRS("comm_Email"),"@","[AT]")&""" onclick=""this.href=(this.href).replace(/\[AT\]/,String.fromCharCode(64));"">"&objRS("comm_Author")&"</a></li>"
					If objRS("comm_HomePage")<>"" Then
						aryMsgTB(2)= "<li class=""msgurl""><a href="""&objRS("comm_HomePage")&""" " & s & " target=""_blank"">"&objRS("comm_HomePage")&"</a></li>"
					Else
						aryMsgTB(2)= ""
					End If
					aryMsgTB(3)= "<li class=""msgarticle"">"& TransferHTML(UBBCode(objRS("comm_Content"),"[link][autolink][font][face]"),"[vbCrlf][nofollow]") &"</li>"
					aryMsgTB(4)= "<li class=""msgtime"">"&objRS("comm_PostTime")&"</li>"
					aryMsgTB(5)= "</ul>" & vbCrlf

				Else

					aryMsgTB(0)= "<ul class=""msg tb"">"
					aryMsgTB(1)= "<li class=""tbname"">"&i&".|"&objRS("comm_Email")&" ("&ZC_MSG014&")</li>"
					aryMsgTB(2)= "<li class=""msgurl""><a href="""&objRS("comm_HomePage")&""" " & s & " target=""_blank"">"&objRS("comm_Author")&"</a></li>"
					aryMsgTB(3)= "<li class=""msgarticle"">"& TransferHTML(objRS("comm_Content"),"[vbCrlf]") &"</li>"
					aryMsgTB(4)= "<li class=""msgtime"">"&objRS("comm_PostTime")&"</li>"
					aryMsgTB(5)= "</ul>" & vbCrlf

				End If

				aryArticleExportMsgTB(i)=Join(aryMsgTB)

				objRS.MoveNext
				If objRS.eof Then Exit For
			Next

		End if

		objRS.Close()
		Set objRS=Nothing

		ExportMsgTB=Join(aryArticleExportMsgTB)

	End Function

	Function ExportCommentPost()

		Dim aryCommentPost(20)

		aryCommentPost(0)= "<div class=""post"" id=""divCommentPost"">"
		aryCommentPost(1)= "<p class=""posttop""><a name=""comment"">"& ZC_MSG024 &":</a></p>"
		aryCommentPost(2)= "<form id=""frmSumbit"" method=""post"" action="""" >"
		aryCommentPost(3)= "<input type=""hidden"" name=""inpId"" id=""inpId"" value=""" & ID  & """ />"
		aryCommentPost(4)= "<input type=""hidden"" name=""inpArticle"" id=""inpArticle"" value="""" />"
		aryCommentPost(5)= "<input type=""hidden"" name=""inpLocation"" id=""inpLocation"" value="""" />"
		aryCommentPost(6)= "<p><input type=""text"" name=""inpName"" id=""inpName"" class=""text"" value="""" size=""28"" tabindex=""1"" /> <label for=""inpName"">"& ZC_MSG001 &"(*)</label></p>"
		aryCommentPost(7)= "<p><input type=""text"" name=""inpEmail"" id=""inpEmail"" class=""text"" value="""" size=""28"" tabindex=""2"" /> <label for=""inpEmail"">"& ZC_MSG053 &"(*)</label></p>"
		aryCommentPost(8)= "<p><input type=""text"" name=""inpHomePage"" id=""inpHomePage"" class=""text"" value="""" size=""28"" tabindex=""3"" /> <label for=""inpHomePage""><acronym title="""& ZC_MSG017 &""" lang=""en"">"& ZC_MSG054 &"</acronym></label></p>"
		If ZC_COMMENT_VERIFY_ENABLE Then
			aryCommentPost(9)= "<script language=""JavaScript"" src="""& ZC_BLOG_HOST &"c_html_js.asp?act=CommentVerify"" type=""text/javascript""></script>"
			aryCommentPost(10)= "<p><input type=""text"" name=""inpVerify"" id=""inpVerify"" class=""text"" value="""" size=""28"" tabindex=""7"" /> <label for=""inpVerify"">"& ZC_MSG089 &"(*)</label> <b id=""frmCommentVerify"" style=""border:1px solid #999999;padding:2px;""><img src="""& ZC_BLOG_HOST &"c_validcode.asp?name=commentvalid&amp;id=1"" height=""14"" width=""10"" alt="""" title=""""/> <img src="""& ZC_BLOG_HOST &"c_validcode.asp?name=commentvalid&amp;id=2"" height=""14"" width=""10"" alt="""" title=""""/> <img src="""& ZC_BLOG_HOST &"c_validcode.asp?name=commentvalid&amp;id=3"" height=""14"" width=""10"" alt="""" title=""""/> <img src="""& ZC_BLOG_HOST &"c_validcode.asp?name=commentvalid&amp;id=4"" height=""14"" width=""10"" alt="""" title=""""/></b></p>"
		End If
		aryCommentPost(11)= "<p><label for=""txaArticle"">"& ZC_MSG055 &"(*)(" & Replace(ZC_MSG056,"%s",ZC_CONTENT_MAX) & ")</label></p>"
		aryCommentPost(12)= "<p><textarea name=""txaArticle"" id=""txaArticle"" onchange=""GetActiveText(this.id);"" onclick=""GetActiveText(this.id);"" onfocus=""GetActiveText(this.id);"" class=""text"" cols=""50"" rows=""4"" tabindex=""4"" ></textarea></p>"
		aryCommentPost(13)= "<p><input name=""btnSumbit"" type=""submit"" tabindex=""5"" value="""& ZC_MSG087 &""" onclick=""JavaScript:return VerifyMessage()"" class=""button"" /> <input type=""checkbox"" name=""chkRemember"" value=""1"" id=""chkRemember"" /> <label for=""chkRemember"">" & ZC_MSG049 & "</label></p>"
		aryCommentPost(14)= "<script language=""JavaScript"" type=""text/javascript"">objActive=""txaArticle"";ExportUbbFrame();</script>"

		aryCommentPost(15)= "<p>" & ZC_MSG040 & "</p>"
		aryCommentPost(16)= "</form><p class=""postbottom"">" & ZC_MSG014 & ":" & TrackBack & "</p>"
		aryCommentPost(17)= "<script language=""JavaScript"" type=""text/javascript"">LoadRememberInfo();</script>"
		aryCommentPost(18)= "</div>"

		ExportCommentPost=Join(aryCommentPost)

	End Function

	Function ExportNavBar()

		Dim strPostNav

		strPostNav="<div class=""post-nav"">"
		Dim objRS
		Set objRS=objConn.Execute("SELECT TOP 1 [log_Title],[log_ID] FROM [blog_Article] WHERE ([log_Level]>2) AND ([log_PostTime]<#" & PostTime & "#) ORDER BY [log_PostTime] DESC")
		If (Not objRS.bof) And (Not objRS.eof) Then
			strPostNav=strPostNav & "<a class=""l"" href="""& ZC_BLOG_HOST &"post/" & objRS("log_ID") & "." & ZC_STATIC_TYPE & """>&laquo; " & objRS("log_Title") & "</a>" 
		End If
		Set objRS=Nothing
		Set objRS=objConn.Execute("SELECT TOP 1 [log_Title],[log_ID] FROM [blog_Article] WHERE ([log_Level]>2) AND ([log_PostTime]>#" & PostTime & "#) ORDER BY [log_PostTime] ASC")
		If (Not objRS.bof) And (Not objRS.eof) Then
			strPostNav=strPostNav & "<a class=""r"" href="""& ZC_BLOG_HOST &"post/" & objRS("log_ID") & "." & ZC_STATIC_TYPE & """>" & objRS("log_Title") & "&raquo; </a>" 
		End If
		Set objRS=Nothing
		strPostNav=strPostNav & "</div>"

		ExportNavBar=strPostNav

	End Function

	Function Build()

		If Not(Level>2) Then Build=True:Exit Function

		Dim objStream
		Dim strNavBar
		Dim strContent


		'静态化过程
		If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_SINGLE"))=False) Then
			strContent=Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_SINGLE")
		End If

		If (IsEmpty(Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_NAVBAR"))=False) Then
			strNavBar=Application(ZC_BLOG_CLSID & "CACHE_INCLUDE_NAVBAR")
		End If


		strContent=Replace(strContent,"<#navbar.asp#>",strNavBar)
		strContent=Replace(strContent,"<#Article.ID#>",ID)
		strContent=Replace(strContent,"<#BlogTitle#>",ZC_BLOG_TITLE & ZC_MSG044 & Title)
		strContent=Replace(strContent,"<#Article.PostTime#>",PostTime)
		strContent=Replace(strContent,"<#Article.Title#>",Title)
		strContent=Replace(strContent,"<#Article.CateID#>",CateID)
		strContent=Replace(strContent,"<#Article.AuthorID#>",AuthorID)
		strContent=Replace(strContent,"<#Article.Level#>",Level)
		strContent=Replace(strContent,"<#Article.TagNameWithLink#>",ZC_MSG138 & ": " & TranslateTagToNameWithLink(Tag))

		strContent=Replace(strContent,"<#ZC_BLOG_COPYRIGHT#>",ZC_BLOG_COPYRIGHT)
		strContent=Replace(strContent,"<#ZC_BLOG_LANGUAGE#>",ZC_BLOG_LANGUAGE)
		strContent=Replace(strContent,"<#ZC_BLOG_CSS#>",ZC_BLOG_CSS)
		strContent=Replace(strContent,"<#ZC_BLOG_VERSION#>",ZC_BLOG_VERSION)
		strContent=Replace(strContent,"<#ZC_BLOG_HOST#>",ZC_BLOG_HOST)
		strContent=Replace(strContent,"<"&"%=ZC_BLOG_HOST%"&">",ZC_BLOG_HOST)
		strContent=Replace(strContent,"<#ZC_BLOG_NAME#>",ZC_BLOG_NAME)
		strContent=Replace(strContent,"<#ZC_BLOG_SUB_NAME#>",ZC_BLOG_SUB_NAME)
		strContent=Replace(strContent,"<#ZC_CONTENT_MAX#>",ZC_CONTENT_MAX)

		strContent=Replace(strContent,"<#ZC_MSG027#>",ZC_MSG027)
		strContent=Replace(strContent,"<#ZC_MSG032#>",ZC_MSG032)
		strContent=Replace(strContent,"<#ZC_MSG033#>",ZC_MSG033)
		strContent=Replace(strContent,"<#ZC_MSG034#>",ZC_MSG034)
		strContent=Replace(strContent,"<#ZC_MSG035#>",ZC_MSG035)
		strContent=Replace(strContent,"<#ZC_MSG050#>",ZC_MSG050)
		strContent=Replace(strContent,"<#ZC_MSG052#>",ZC_MSG052)
		strContent=Replace(strContent,"<#ZC_MSG057#>",ZC_MSG057)



		strContent=Replace(strContent,"<#Article.Export#>",Export(ZC_DISPLAY_MODE_ALL))

		If CommNums + TrackBackNums >0 Then
			strContent=Replace(strContent,"<#Article.ExportMsgTB#>",ExportMsgTB)
		Else
			strContent=Replace(strContent,"<#Article.ExportMsgTB#>","")
		End If

		If Level=4 Then
			strContent=Replace(strContent,"<#Article.ExportCommentPost#>",ExportCommentPost)
		Else
			strContent=Replace(strContent,"<#Article.ExportCommentPost#>","")
		End If



		strContent=TransferHTML(strContent,"[no-asp]")
		If ZC_STATIC_TYPE="asp" Then
			strContent="<"&"%@ CODEPAGE=65001 %"&">" & strContent
		End If

		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.WriteText=strContent
		.SaveToFile BlogPath & "/post/" & ID & "." & ZC_STATIC_TYPE,adSaveCreateOverWrite
		.Close
		End With

		Set objStream = NoThing

		Build=True

	End Function

	Function BuildCache()

		If Not(Level>1) Then BuildCache=True:Exit Function

		Dim strList
		Dim objStream

		strList=Export(ZC_DISPLAY_MODE_INTRO)
		strList=TransferHTML(strList,"[no-asp]")

		Set objStream = Server.CreateObject("ADODB.Stream")
		With objStream
		.Type = adTypeText
		.Mode = adModeReadWrite
		.Open
		.Charset = "utf-8"
		.Position = objStream.Size
		.WriteText = strList
		.SaveToFile BlogPath & "/cache/" & ID & ".asp",adSaveCreateOverWrite
		.Close
		End With
		Set objStream = Nothing

		BuildCache=True

	End Function

	Private Sub Class_Initialize()
		PostTime=Now()
		ID=0
		CateID=0
		AuthorID=0
		Level=4'默认为普通
		Title=ZC_MSG099
		IP=Request.Servervariables("REMOTE_ADDR")
	End Sub


End Class
'*********************************************************




'*********************************************************
' 目的：    定义TArticleList类
' 输入：    无
' 返回：    无
'*********************************************************
Class TArticleList

	Public PageCount
	Public ExportList

	Private Article

	Public Function Export(intPage,intCateId,intAuthorId,dtmYearMonth,strTagsName,intType)

		Dim i
		Dim aryListExport()
		Dim objRS
		Dim intPageCount

		Call CheckParameter(intPage,"int",1)
		Call CheckParameter(intCateId,"int",Empty)
		Call CheckParameter(intAuthorId,"int",Empty)
		Call CheckParameter(dtmYearMonth,"dtm",Empty)


		Set objRS=Server.CreateObject("ADODB.Recordset")
		objRS.CursorType = adOpenKeyset
		objRS.LockType = adLockReadOnly
		objRS.ActiveConnection=objConn
		objRS.Source="SELECT [log_ID] FROM [blog_Article] WHERE ([log_ID]>0) AND ([log_Level]>1)"

		If Not IsEmpty(intCateId) Then
			objRS.Source=objRS.Source & "AND([log_CateID]="&intCateId&")"
		End if
		If Not IsEmpty(intAuthorId) Then
			objRS.Source=objRS.Source & "AND([log_AuthorID]="&intAuthorId&")"
		End if
		If IsDate(dtmYearMonth) Then

			Dim y
			Dim m
			Dim ny
			Dim nm

			If IsDate(dtmYearMonth) Then
				dtmYearMonth=CDate(dtmYearMonth)
			Else
				Call showError(3)
			End If

			y=year(dtmYearMonth)
			m=month(dtmYearMonth)
			ny=y
			nm=m+1
			If m=12 Then ny=ny+1:nm=1

			objRS.Source=objRS.Source & "AND([log_PostTime] BETWEEN #"&y&"-"&m&"-1# AND #"&ny&"-"&nm&"-1#)"
		End if
		objRS.Source=objRS.Source & "ORDER BY [log_PostTime] DESC,[log_ID] DESC"
		objRS.Open()

		If (Not objRS.bof) And (Not objRS.eof) Then
			objRS.PageSize = ZC_DISPLAY_COUNT
			intPageCount=objRS.PageCount
			objRS.AbsolutePage = intPage

			PageCount=intPageCount

			ReDim aryListExport(objRS.PageSize)

			For i = 1 To objRS.PageSize

				If Article.LoadInfobyID(objRS("log_ID")) Then

					aryListExport(i-1)= Article.Export(intType)

				End If

				objRS.MoveNext
				If objRS.EOF Then Exit For

			Next

			aryListExport(objRS.PageSize)= ExportBar(intPage,intPageCount,intCateId,intAuthorId,dtmYearMonth,strTagsName)

		Else

			Exit Function

		End If

		objRS.Close()
		Set objRS=Nothing

		ExportList=Join(aryListExport)
		Export=True

	End Function

	Function Search(strQuestion)

		Dim i
		Dim j
		Dim objRS
		Dim intPageCount
		Dim aryListExport

		strQuestion=Trim(strQuestion)

		If CheckRegExp(strQuestion,"^$") Then  Exit Function
		'If CheckRegExp(strQuestion,"^[\u0001-\u4dff]$") Then  Exit Function
		If CheckRegExp(strQuestion,"[\u3040-\u30ff]+") Then Exit Function

		strQuestion=FilterSQL(strQuestion)

		Set objRS=Server.CreateObject("ADODB.Recordset")
		objRS.CursorType = adOpenKeyset
		objRS.LockType = adLockReadOnly
		objRS.ActiveConnection=objConn

		objRS.Source="SELECT [log_ID] FROM [blog_Article] WHERE ([log_ID]>0) AND ([log_Level]>2)"

		objRS.Source=objRS.Source & "AND (([log_Title] LIKE '%" & strQuestion & "%') OR ([log_Intro] LIKE '%" & strQuestion & "%') OR ([log_Content] LIKE '%" & strQuestion & "%')) "

		objRS.Source=objRS.Source & "ORDER BY [log_PostTime] DESC,[log_ID] DESC"

		objRS.Open()

		Response.Write "<div class=""post"">" & Replace(Replace(ZC_MSG086,"%s","<strong>" & TransferHTML(Replace(strQuestion,Chr(39)&Chr(39),Chr(39)),"[<][>][&][""]") & "</strong>",vbTextCompare,1),"%s","<strong>" & objRS.RecordCount & "</strong>") & "</div>" & vbCrlf

		If (Not objRS.bof) And (Not objRS.eof) Then
			objRS.PageSize = ZC_SEARCH_COUNT
			intPageCount=objRS.PageCount
			objRS.AbsolutePage = 1

			ReDim aryListExport(objRS.PageSize)

			For i = 1 To objRS.PageSize

				If Article.LoadInfobyID(objRS("log_ID")) Then
					aryListExport(i-1)=Article.Export(ZC_DISPLAY_MODE_SEARCH)
				End If

				objRS.MoveNext
				If objRS.EOF Then Exit For

			Next

		End If

		objRS.Close()
		Set objRS=Nothing

		ExportList=Join(aryListExport)

		Search=True

	End Function

	Private Sub Class_Initialize()

		Set Article=New TArticle

	End Sub


End Class
'*********************************************************




'*********************************************************
' 目的：    定义TUser类
' 输入：    无
' 返回：    无
'*********************************************************
Class TUser

	Public ID
	Public Level
	Public Name
	Public Password

	Public Sex
	Public Email
	Public MSN
	Public QQ
	Public HomePage
	Public Intro

	Public Count

	Public LastVisitTime
	Public LastVisitIP

	Public Function Verify()
		Dim strUserName
		Dim  strPassWord

		strPassWord=Request.Cookies("password")
		If (strPassWord="") Then Exit Function

		strUserName=vbsunescape(Request.Cookies("username"))
		If (strUserName="") Then Exit Function

		strUserName=FilterSQL(strUserName)
		strPassWord=FilterSQL(strPassWord)

		'校检
		If Len(strUserName) >ZC_USERNAME_MAX Then Call ShowError(7)
		If Len(strPassWord)<>ZC_PASSWORD_MAX Then Call ShowError(7)
		If Not CheckRegExp(strUserName,"^[.A-Za-z0-9\u4e00-\u9fa5]+$") Then Call ShowError(7)
		If Not CheckRegExp(strPassWord,"^[a-z0-9]+$") Then Call ShowError(7)

		Dim objRS
		Set objRS=objConn.Execute("SELECT [mem_ID],[mem_Level],[mem_Password] FROM [blog_Member] WHERE [mem_Name]='"&strUserName & "'" )

		If (Not objRS.Bof) And (Not objRS.Eof) Then
			If StrComp(strPassWord,objRS("mem_Password"))=0 Then

				ID=objRS("mem_ID")
				LoadInfobyID(ID)
				Verify=True

			Else
				Response.Cookies("password")=""
			End If
		Else
			Response.Cookies("password")=""
		End If

		objRS.Close
		Set objRS=Nothing

	End Function

	Function LoadInfobyID(user_ID)

		Call CheckParameter(user_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT [mem_ID],[mem_Name],[mem_Level],[mem_Password],[mem_Email],[mem_HomePage],[mem_PostLogs] FROM [blog_Member] WHERE [mem_ID]=" & user_ID)
		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("mem_ID")
			Name=objRS("mem_Name")
			Level=objRS("mem_Level")
			Password=objRS("mem_Password")
			Email=objRS("mem_Email")
			HomePage=objRS("mem_HomePage")
			Count=objRS("mem_PostLogs")

			If IsNull(Email) Or IsEmpty(Email) Or Len(Email)=0 Then Email="a@b.com"

			LoadInfobyID=True
		End If
		objRS.Close
		Set objRS=Nothing

	End Function

	Public Function LoadInfoByArray(aryUserInfo)

		If IsArray(aryUserInfo)=True Then

			ID=aryUserInfo(0)
			Name=aryUserInfo(1)
			Level=aryUserInfo(2)
			Password=aryUserInfo(3)
			Email=aryUserInfo(4)
			HomePage=aryUserInfo(5)
			Count=aryUserInfo(6)

		End If

		If IsNull(Email) Or IsEmpty(Email) Or Len(Email)=0 Then Email="a@b.com"

		LoadInfoByArray=True

	End Function



	Function Edit(currentUser)


		Call CheckParameter(ID,"int",0)
		Call CheckParameter(Level,"int",0)

		If ((Level<1) Or (Level>5)) Then Call ShowError(16)
		If (Name="") Then Call ShowError(7)
		If Len(Name) >ZC_USERNAME_MAX Then Call ShowError(7)
		If Not CheckRegExp(Name,"^[.A-Za-z0-9\u4e00-\u9fa5]+$") Then Call ShowError(7)

		Email=FilterSQL(Email)
		HomePage=FilterSQL(HomePage)

		Email=TransferHTML(Email,"[<][>][&][""]")
		HomePage=TransferHTML(HomePage,"[<][>][&][""]")

		If Len(Email)=0 Then Call ShowError(29)
		If Len(Email)>ZC_EMAIL_MAX Then Call ShowError(29)
		If Len(HomePage)>ZC_HOMEPAGE_MAX Then Call ShowError(29)

		If Not CheckRegExp(Email,"^([0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*@([0-9a-zA-Z][-\w]*\.)+[a-zA-Z]*)$") Then Call ShowError(30)
		IF Len(HomePage)>0 Then
			If Not CheckRegExp(HomePage,"^[a-zA-z]+://[a-zA-z0-9\-\./]+?/*$") Then Call ShowError(30)
		End If

		If ID=0 Then

			If Level <= currentUser.Level Then ShowError(6)
			If Len(PassWord)<>ZC_PASSWORD_MAX Then Call ShowError(7)
			If Not CheckRegExp(PassWord,"^[a-z0-9]+$") Then Call ShowError(7)

			objConn.Execute("INSERT INTO [blog_Member]([mem_Level],[mem_Name],[mem_PassWord],[mem_Email],[mem_HomePage]) VALUES ("&Level&",'"&Name&"','"&PassWord&"','"&Email&"','"&HomePage&"')")
			Edit=True

		Else

			If (ID=currentUser.ID) And (Level <> currentUser.Level) Then ShowError(6)
			If (ID<>currentUser.ID) And (Level <= currentUser.Level) Then ShowError(6)

			Dim targetUser
			Set targetUser=New TUser
			If targetUser.LoadInfobyID(ID) Then

				If Len(PassWord)=0 Then PassWord=targetUser.PassWord
				If Len(PassWord)<>ZC_PASSWORD_MAX Then Call ShowError(6)
				If Not CheckRegExp(PassWord,"^[a-z0-9]+$") Then Call ShowError(7)

			Else
				Exit Function
			End If

			objConn.Execute("UPDATE [blog_Member] SET [mem_Level]="&Level&",[mem_Name]='"&Name&"',[mem_PassWord]='"&PassWord&"',[mem_Email]='"&Email&"',[mem_HomePage]='"&HomePage&"' WHERE [mem_ID]="&ID)

			If Name <> targetUser.Name Then
				objConn.Execute("UPDATE [blog_Comment] SET [comm_Author]='"&Name&"' WHERE [comm_AuthorID]="&ID)
			End If
			If Email <> targetUser.Email Then
				objConn.Execute("update [blog_Comment] set [comm_Email]='"&Email&"' where [comm_AuthorID]="&ID)
			End If

			Edit=True

			If (ID=currentUser.ID) Then Response.Redirect "cmd.asp?act=login"

		End If

	End Function

	Function Del(currentUser)

		Call CheckParameter(ID,"int",0)
		Call CheckParameter(Level,"int",0)

		Dim targetUser
		Set targetUser=New TUser
		If targetUser.LoadInfobyID(ID) Then
			If targetUser.Level<= currentUser.Level Then ShowError(6)
			If currentUser.ID = targetUser.ID Then ShowError(17)
		Else
			Exit Function
		End If

		objConn.Execute("DELETE FROM [blog_Member] WHERE [mem_ID] =" & ID)

		Del=True
	End Function

	Private Sub Class_Initialize()

		Level=5
		ID=0
		Name=ZC_MSG018

		Sex=0
		Email=""
		MSN=""
		QQ=""
		HomePage=""
		Intro=""

	End Sub

	Private Sub Class_Terminate()

	End Sub

End Class
'*********************************************************




'*********************************************************
' 目的：    定义TComment类
' 输入：    无
' 返回：    无
'*********************************************************
Class TComment

	Public ID
	Public log_ID

	Public AuthorID
	Public Author
	Public Content
	Public Email
	Public HomePage

	Public PostTime
	Public IP
	Public Agent

	Public Function Post()

		PostTime=Now()
		IP=Request.ServerVariables("REMOTE_ADDR")
		Agent=Request.ServerVariables("HTTP_USER_AGENT")

		If Len(HomePage)>0 Then
			If InStr(HomePage,"http")=0 Then HomePage="http://" & HomePage
		End If

		If Len(Content)>ZC_CONTENT_MAX Then Content=Left(Content,ZC_CONTENT_MAX)&"..."

		'检查参数
		Call CheckParameter(log_ID,"int",0)
		Call CheckParameter(AuthorID,"int",0)

		Author=FilterSQL(Author)
		Content=FilterSQL(Content)
		Email=FilterSQL(Email)
		HomePage=FilterSQL(HomePage)

		PostTime=FilterSQL(PostTime)
		IP=FilterSQL(IP)
		Agent=FilterSQL(Agent)

		'log_ID不能为0
		If (log_ID=0) Then Post=False:Exit Function
		If Len(Author)=0 Then Post=False:Exit Function
		If Len(Email)=0 Then Post=False:Exit Function
		If Len(Content)=0 Then Post=False:Exit Function


		Author=TransferHTML(Author,"[<][>][&][""]")
		Email=TransferHTML(Email,"[<][>][&][""]")
		HomePage=TransferHTML(HomePage,"[<][>][&][""]")
		Content=TransferHTML(Content,"[<][>][&][""]")

		If Len(Author)>ZC_USERNAME_MAX Then Post=False:Exit Function
		If Len(Email)>ZC_EMAIL_MAX Then Post=False:Exit Function
		If Len(HomePage)>ZC_HOMEPAGE_MAX Then Post=False:Exit Function

		IF Len(HomePage)>0 Then
			If Not CheckRegExp(HomePage,"^[a-zA-z]+://[a-zA-z0-9\-\./]+?/*$") Then Call  ShowError(30)
		End If

		If Not CheckRegExp(Author,"^[.A-Za-z0-9\u4e00-\u9fa5]+$") Then Call  ShowError(15)
		If Not CheckRegExp(Email,"^([0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*@([0-9a-zA-Z][-\w]*\.)+[a-zA-Z]*)$") Then Call  ShowError(29)


		Dim objRS
		Dim strSpamIP
		Dim strSpamContent

		Set objRS=objConn.Execute("SELECT [comm_IP],[comm_Content] FROM [blog_Comment] WHERE [comm_ID]= ( SELECT MAX(comm_ID) FROM [blog_Comment] )")

		If (Not objRS.bof) And (Not objRS.eof) Then
			strSpamIP=objRS("comm_IP")
			strSpamContent=objRS("comm_Content")
		End If

		objRS.Close
		Set objRS=Nothing

		If (strSpamIP=IP) And (strSpamContent=Content) Then
			Call ShowError(0)
		End If

		objConn.Execute("INSERT INTO [blog_Comment]([log_ID],[comm_AuthorID],[comm_Author],[comm_Content],[comm_Email],[comm_HomePage],[comm_IP],[comm_PostTime],[comm_Agent]) VALUES ("&log_ID&","&AuthorID&",'"&Author&"','"&Content&"','"&Email&"','"&HomePage&"','"&IP&"','"&PostTime&"','"&Agent&"')")

		Post=True

	End Function

	Public Function Del()
		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function
		objConn.Execute("DELETE FROM [blog_Comment] WHERE [comm_ID] =" & ID)
		Del=True
	End Function

End Class
'*********************************************************




'*********************************************************
' 目的：    定义TTrackBack类
' 输入：    无
' 返回：    无
'*********************************************************
Class TTrackBack

	Public ID
	Public log_ID

	Public URL
	Public Title
	Public Blog
	Public Excerpt


	Public PostTime
	Public IP
	Public Agent

	Private Function ReturnTbXML(strMsg)

		Dim strXML

		strXML="<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?><response><error>%e</error><message>%m</message></response>"

		If strMsg="undiscovered" Then'未发现相应ID
			strXML=Replace(strXML,"%e","1")
			strXML=Replace(strXML,"%m",strMsg)
		ElseIf strMsg="repetition" Then'重复PING
			strXML=Replace(strXML,"%e","1")
			strXML=Replace(strXML,"%m",strMsg)
		Elseif strMsg="invalid parameter" Then'非法参数
			strXML=Replace(strXML,"%e","1")
			strXML=Replace(strXML,"%m",strMsg)
		Elseif strMsg="none data" Then'无数据
			strXML=Replace(strXML,"%e","1")
			strXML=Replace(strXML,"%m",strMsg)
		Else'PING 成功
			strXML=Replace(strXML,"%e","0")
			strXML=Replace(strXML,"%m",strMsg)
		End If

		'Response.ContentType = "text/html"
		Response.ContentType = "text/xml"
		Response.Clear
		Response.Write strXML

	End Function


	Public Function Post()

		'Call ReturnTbXML("undiscovered"):Exit Function
		Call CheckParameter(log_ID,"int",0)

		PostTime=Now()
		IP=Request.ServerVariables("REMOTE_ADDR")
		Agent=Request.ServerVariables("HTTP_USER_AGENT")

		IP=FilterSQL(IP)
		Agent=FilterSQL(Agent)

		URL=FilterSQL(URL)
		Title=FilterSQL(Title)
		Blog=FilterSQL(Blog)
		Excerpt=FilterSQL(Excerpt)

		Blog=TransferHTML(Blog,"[<][>][&][""]")
		Title=TransferHTML(Title,"[<][>][&][""]")
		Excerpt=TransferHTML(Excerpt,"[<][>][&][""][nohtml]")
		URL=TransferHTML(URL,"[<][>][&][""]")

		'log_ID不能为0
		If (log_ID=0) Then Call ReturnTbXML("invalid parameter"):Post=False:Exit Function
		If Len(URL)=0 Then Call ReturnTbXML("none data"):Post=False:Exit Function
		If Len(URL)>ZC_HOMEPAGE_MAX Then Call ReturnTbXML("url is long"):Post=False:Exit Function

		If Len(Blog)>ZC_EMAIL_MAX Then Call ReturnTbXML("name is long"):Post=False:Exit Function
		If Len(Blog)=0 Then Blog="Unknow"
		If Len(Excerpt)=0 Then Excerpt=""
		If Len(Excerpt)>ZC_TB_EXCERPT_MAX Then Excerpt=Left(Excerpt,ZC_TB_EXCERPT_MAX)&"..."
		If Len(Title)>ZC_HOMEPAGE_MAX Then Call ReturnTbXML("title is long"):Post=False:Exit Function
		If Len(Title)=0 Then Title=URL


	'检查ID是否存在
		Dim objRS
		Set objRS=objConn.Execute("SELECT * FROM [blog_Article] WHERE [log_ID]=" & log_ID)
		If (Not objRS.bof) And (Not objRS.eof) Then
		Else
			objRS.close
			Call returnTbXML("undiscovered")
			Exit Function
		End If
		objRS.Close
		Set objRS=Nothing

	'检查是否已TB过
		Set objRS=objConn.Execute("SELECT * FROM [blog_TrackBack] WHERE [log_ID]=" & log_ID & " and [tb_url]='" & URL & "'")
		If (Not objRS.bof) And (Not objRS.eof) Then
			objRS.close
			Call returnTbXML("repetition")
			Exit Function
		End If
		objRS.Close
		Set objRS=Nothing

	'接收TB
		objConn.Execute("INSERT INTO [blog_TrackBack]([log_ID],[tb_URL],[tb_Title],[tb_Blog],[tb_Excerpt],[tb_PostTime],[tb_IP],[tb_Agent]) VALUES ("&log_ID&",'"&URL&"','"&Title&"','"&Blog&"','"&Excerpt&"','"&PostTime&"','"&IP&"','"&Agent&"')")
		Call returnTbXML("succeed")

		Post=True

	End Function

	Public Function Del()
		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function
		objConn.Execute("DELETE FROM [blog_TrackBack] WHERE [tb_ID] =" & ID)
		Del=True
	End Function


	Function Send(strAddress)

		Dim strSendTB
		strSendTB = "title=" & Server.URLEncode(Title) & "&url=" & Server.URLEncode(URL) & "&excerpt=" & Server.URLEncode(Excerpt) & "&blog_name=" & Server.URLEncode(Blog)

		Dim objPing
		Set objPing = Server.CreateObject("MSXML2.ServerXMLHTTP")

		objPing.open "POST",strAddress,False

		objPing.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
		objPing.send strSendTB
		'Response.ContentType = "text/xml"
		'Response.Clear
		'Response.Write objPing.responseXML.xml
		Set objPing = Nothing
		Send=True

	End Function


End Class
'*********************************************************



'*********************************************************
' 目的：    定义TUpLoadFile类
' 输入：    无
' 返回：    无
'*********************************************************
Class TUpLoadFile

	Public ID
	Public AuthorID

	Public FileSize
	Public FileName
	Public PostTime


	Public Function LoadInfoByID(ul_ID)

		Call CheckParameter(ul_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT * FROM [blog_UpLoad] WHERE [ul_ID]=" & ul_ID)

		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("ul_ID")
			AuthorID=objRS("ul_AuthorID")

			FileSize=objRS("ul_FileSize")
			FileName=objRS("ul_FileName")
			PostTime=objRS("ul_PostTime")

		Else
			Exit Function
		End If

		objRS.Close
		Set objRS=Nothing

		LoadInfobyID=True

	End Function


	Public Function UpLoad(bolAutoName)

		Dim i,j
		Dim x,y,z
		Dim intFormSize
		Dim binFormData
		Dim strFileName

		intFormSize = Request.TotalBytes
		binFormData = Request.BinaryRead(intFormSize)


		i=InstrB(binFormData,ChrB(13)&ChrB(10)&ChrB(13)&ChrB(10))
		i=i+3
		j=InStrB(binFormData,ChrB(13)&ChrB(10)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45)&ChrB(45))

		x=InstrB(binFormData,ChrB(&H66)&ChrB(&H69)&ChrB(&H6C)&ChrB(&H65)&ChrB(&H6E)&ChrB(&H61)&ChrB(&H6D)&ChrB(&H65)&ChrB(&H3D)&ChrB(&H22))
		y=InstrB(x+11,binFormData,ChrB(&H22))
		For z=1 to y-x-10
			strFileName=strFileName & Chr(AscB(MidB(binFormData,x+z+9,1)))
		Next
		x=InStrRev(strFileName,"\")
		If x>0 Then
			strFileName=Mid(strFileName,x+1)
		End If

		'超出类型限制
		If Not CheckRegExp(LCase(strFileName),"\.("& ZC_UPLOAD_FILETYPE &")$") Then Call ShowError(26)

		'超出大小限制
		If LenB(binFormData)>ZC_UPLOAD_FILESIZE Then Call ShowError(27)

		Dim objStreamUp
		Set objStreamUp = Server.CreateObject("ADODB.Stream")

		Dim objStreamFile
		Set objStreamFile = Server.CreateObject("ADODB.Stream")

		objStreamFile.Type = adTypeBinary
		objStreamFile.Mode = adModeReadWrite
		objStreamFile.Open

		With objStreamUp
			.Type = adTypeBinary
			.Mode = adModeReadWrite
			.Open
			.Position = 0
			.Write binFormData
			.Position = i
			.CopyTo objStreamFile,j-i-1
			.Close
		End With

		FileName=FilterSQL(strFileName)
		If bolAutoName=True Then
			Randomize
			i=0
			i=InStrRev(FileName,".")
			FileName=Year(Now) & Right("0"&Month(Now),2) & Right("0"&Day(Now),2) & Right("0"&Hour(Now),2) & Right("0"&Minute(Now),2) & Right("0"&Second(Now),2) & Int(9 * Rnd) & Int(9 * Rnd) & Int(9 * Rnd) & Int(9 * Rnd) & Right(FileName,Len(FileName)-InStrRev(FileName,".")+1)
		End If

		Dim objRS
		Set objRS=objConn.Execute("SELECT * FROM [blog_UpLoad] WHERE [ul_FileName] = '" & FileName & "'")

		If (Not objRS.bof) And (Not objRS.eof) Then
			'不能重名
			 Call ShowError(28)
		Else

			FileSize=objStreamFile.Size

			PostTime=Now()

			objConn.Execute("insert into [blog_UpLoad]([ul_AuthorID],[ul_FileSize],[ul_FileName],[ul_PostTime]) values ("& AuthorID &","& FileSize &",'"& FileName &"','"& PostTime &"')")

			objStreamFile.SaveToFile BlogPath & "/upload/" & FileName,adSaveCreateOverWrite
			objStreamFile.Close

		End If

		UpLoad=True

	End Function

	Public Function Del()

		Call CheckParameter(ID,"int",0)

		Dim objRS

		Set objRS=objConn.Execute("SELECT * FROM [blog_UpLoad] WHERE [ul_ID] = " & ID)

		If (Not objRS.bof) And (Not objRS.eof) Then


			Dim fso
			Set fso = CreateObject("Scripting.FileSystemObject")

			If fso.FileExists(BlogPath & "/upload/" & objRS("ul_FileName")) Then
				fso.DeleteFile(BlogPath & "/upload/" & objRS("ul_FileName"))
			End If

			objConn.Execute("DELETE FROM [blog_UpLoad] WHERE [ul_ID] =" & ID)

		Else

			Exit Function

		End If

		objRS.Close
		Set objRS=Nothing


		Del=True

	End Function


End Class
'*********************************************************




'*********************************************************
' 目的：    定义TTag类
' 输入：    无
' 返回：    无
'*********************************************************
Class TTag

	Public ID
	Public Name
	Public Intro
	Public Order
	Public Count

	Public Function Post()

		Call CheckParameter(ID,"int",0)
		Call CheckParameter(Order,"int",0)

		Name=FilterSQL(Name)
		Name=TransferHTML(Name,"[<][>][&][""]")
		If Len(Name)=0 Then Post=False:Exit Function

		Intro=FilterSQL(Intro)
		Intro=TransferHTML(Intro,"[<][>][&][""]")


		If ID=0 Then
			objConn.Execute("INSERT INTO [blog_Tag]([tag_Name],[tag_Order],[tag_Intro]) VALUES ('"&Name&"',"&Order&",'"&Intro&"')")
		Else
			objConn.Execute("UPDATE [blog_Tag] SET [tag_Name]='"&Name&"',[tag_Order]="&Order&",[tag_Intro]='"&Intro&"' WHERE [tag_ID] =" & ID)
		End If

		Post=True

	End Function


	Public Function LoadInfoByID(tag_ID)

		Call CheckParameter(tag_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT [tag_ID],[tag_Name],[tag_Intro],[tag_Order],[tag_Count] FROM [blog_Tag] WHERE [tag_ID]=" & tag_ID)

		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("tag_ID")
			Name=objRS("tag_Name")
			Intro=objRS("tag_Intro")
			Order=objRS("tag_Order")
			Count=objRS("tag_Count")

		Else
			Exit Function
		End If

		objRS.Close
		Set objRS=Nothing

		LoadInfoByID=True

	End Function

	Public Function LoadInfoByArray(aryTagInfo)

		If IsArray(aryTagInfo)=True Then
			ID=aryTagInfo(0)
			Name=aryTagInfo(1)
			Intro=aryTagInfo(2)
			Order=aryTagInfo(3)
			Count=aryTagInfo(4)
		End If

		LoadInfoByArray=True

	End Function


	Public Function Del()

		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function

		Dim s
		Dim i
		Dim objRS

		Set objRS=Server.CreateObject("ADODB.Recordset")
		objRS.CursorType = adOpenKeyset
		objRS.LockType = adLockReadOnly
		objRS.ActiveConnection=objConn
		objRS.Source=""

		objRS.Open("SELECT [log_ID],[log_tag] FROM [blog_Article] WHERE [log_Tag] LIKE '%{" & ID & "}%'")

		If (Not objRS.bof) And (Not objRS.eof) Then
			Do While Not objRS.eof
				i=objRS("log_ID")
				s=objRS("log_tag")
				s=Replace(s,"{"& ID &"}","")
				objConn.Execute("UPDATE [blog_Article] SET [log_tag]='"& s &"' WHERE [log_ID] =" & i)
				objRS.MoveNext
			Loop
		End If
		objRS.Close

		objConn.Execute("DELETE FROM [blog_Tag] WHERE [tag_ID] =" & ID)
		Del=True
	End Function

End Class
'*********************************************************




'*********************************************************
' 目的：    定义TKeyWord类
' 输入：    无
' 返回：    无
'*********************************************************
Class TKeyWord

	Public ID
	Public Name
	Public Intro
	Public Url

	Public Function Post()

		Call CheckParameter(ID,"int",0)

		Name=FilterSQL(Name)
		If Len(Name)=0 Then Post=False:Exit Function

		Intro=FilterSQL(Intro)
		Intro=TransferHTML(Intro,"[<][>][&][""]")

		Url=FilterSQL(Url)
		Url=TransferHTML(Url,"[<][>][&][""]")
		If Len(Url)=0 Then Post=False:Exit Function
		If Not CheckRegExp(Url,"^[a-zA-z]+://[a-zA-z0-9\-\./]+?/*$") Then Call  ShowError(30)

		If ID=0 Then
			objConn.Execute("INSERT INTO [blog_Keyword]([key_Name],[key_URL],[key_Intro]) VALUES ('"&Name&"','"&Url&"','"&Intro&"')")
		Else
			objConn.Execute("UPDATE [blog_Keyword] SET [key_Name]='"&Name&"',[key_URL]='"&Url&"',[key_Intro]='"&Intro&"' WHERE [key_ID] =" & ID)
		End If

		Post=True

	End Function


	Public Function LoadKeyWordInfoByID(key_ID)

		Call CheckParameter(key_ID,"int",0)

		Dim objRS
		Set objRS=objConn.Execute("SELECT * FROM [blog_Keyword] WHERE [key_ID]=" & key_ID)

		If (Not objRS.bof) And (Not objRS.eof) Then

			ID=objRS("key_ID")
			Name=objRS("key_Name")
			Intro=objRS("key_Intro")
			Url=objRS("key_Url")

		Else
			Exit Function
		End If

		objRS.Close
		Set objRS=Nothing

		LoadKeyWordInfoByID=True

	End Function


	Public Function Del()

		Call CheckParameter(ID,"int",0)
		If (ID=0) Then Del=False:Exit Function

		objConn.Execute("DELETE FROM [blog_Keyword] WHERE [key_ID] =" & ID)
		Del=True
	End Function

End Class
'*********************************************************
%>